package mikroe.com.myapplication;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.ImageButton;
import android.widget.Toast;

public class RelaysControl extends Activity {

    private BtInterface BT_RN41 = null;
    private long lastTime = 0;
    private ImageButton mRelay1;
    private ImageButton mRelay2;
    private boolean relay1_state = false;
    private boolean relay2_state = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_relays_control);

        mRelay1 = (ImageButton) findViewById(R.id.btRelay1);
        mRelay1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

               if(RN41.SOCKET == RN41.SOCKET_STATE.CONNECTED) {
                   String wr_data;
                   if(relay1_state) {
                       relay1_state = false;
                       wr_data = "RELAY1=0"  + (char)0x0A;
                       mRelay1.setImageResource(R.drawable.off_switch_btn);
                   }else{
                       relay1_state = true;
                       wr_data = "RELAY1=1"  + (char)0x0A;
                       mRelay1.setImageResource(R.drawable.on_switch_btn);
                   }

                   BT_RN41.SendData(wr_data);

               }
            }
        });

        mRelay2 = (ImageButton) findViewById(R.id.btRelay2);
        mRelay2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(RN41.SOCKET == RN41.SOCKET_STATE.CONNECTED) {
                    String wr_data;
                    if(relay2_state) {
                        relay2_state = false;
                        wr_data = "RELAY2=0"  + (char)0x0A;
                        mRelay2.setImageResource(R.drawable.off_switch_btn);
                    }else{
                        relay2_state = true;
                        wr_data = "RELAY2=1"  + (char)0x0A;
                        mRelay2.setImageResource(R.drawable.on_switch_btn);
                    }

                    BT_RN41.SendData(wr_data);

                }
            }
        });


        BT_RN41 = new BtInterface(handlerStatus, handler);
    }



    @Override
    protected void onResume() {
        super.onResume();
        if (BT_RN41 == null) {
            BT_RN41 = new BtInterface(handlerStatus, handler);
        }

    }



    @Override
    protected void onPause() {
        super.onPause();
        if (BT_RN41 != null) {
            BT_RN41.close();
            BT_RN41 = null;
        }

    }



    private void SyncData() {
        if(RN41.SOCKET == RN41.SOCKET_STATE.CONNECTED) {
            String wr_data = "GET" + (char) 0x0A;
            BT_RN41.SendData(wr_data);
        }
    }





    ////////////////////////////////////////////////////////////////////////////////////////////////
    //                                   BT RN41
    ////////////////////////////////////////////////////////////////////////////////////////////////

    final Handler handler = new Handler() {
        public void handleMessage(Message msg) {
            String data = msg.getData().getString("receivedData");
            //parse received data
            if (data.contains("SET")) {
                //Relay1
                if(data.charAt(4) == 49){

                    relay1_state = true;

                    mRelay1.setImageResource(R.drawable.on_switch_btn);
                }else{

                    relay1_state = false;

                    mRelay1.setImageResource(R.drawable.off_switch_btn);

                }
                //Relay2
                if(data.charAt(5) == 49){

                    relay2_state = true;

                    mRelay2.setImageResource(R.drawable.on_switch_btn);
                }else{

                    relay2_state = false;

                    mRelay2.setImageResource(R.drawable.off_switch_btn);
                }

            }

            long t = System.currentTimeMillis();
            if(t-lastTime > 100) {
                lastTime = System.currentTimeMillis();
            }

        }
    };

    final Handler handlerStatus = new Handler() {
        public void handleMessage(Message msg) {
            int co = msg.arg1;
            if(co == 1) { //Connection success

                Toast.makeText(getApplicationContext(), "RELAYS CONNECTED", Toast.LENGTH_LONG).show();

                SyncData();

            } else if(co == 2) { //Connection error
                Toast.makeText(getApplicationContext(),"ERROR!",Toast.LENGTH_LONG).show();

            }


        }
    };

}
